/*


    Evolute version 0.7
    Copyright (C) 2010 Antti Vainio

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

//          survivalmapit.cpp

#include <math.h>
#include "global.hpp"

//karttavalikko
void survival() {
     bool pois1 = false; //aloita poistuminen
     bool pois2 = false; //ulos loopista!
     float kasautuminen = 0;
     float nappikasautuminen = 0;
     bool napit = false;
     short int valinta = 0;
     short int prewvalinta = 0;
     short int mappivalinta = -10;
     short progressmaara = 0;
     
     //luetaan progress
     tiedosto = fopen("maps/Stages/progress.dat", "r");
     if(tiedosto == NULL) {
                 luoprogressf(0);
                 tiedosto = fopen("maps/Stages/progress.dat", "r");
     }
     if(tiedosto != NULL) {
                 char c;
                 for(int i=0;i<10;i++) {
                         c = getc(tiedosto);
                         if(c != '0') progressmaara++;
                 }
                 fclose(tiedosto);
     }
     
     while(!pois2) {
                 alkuaika = SDL_GetTicks();
                 
                 //hiiri ja nappulat
                 SDL_GetMouseState(&hiirix,&hiiriy);
                 pelaajaninputit = SDL_GetKeyState(NULL);
                 if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)) hiiriekanappi = true;
                 else hiiriekanappi = false;
                 
                 //lasketaan kasautuminen
                 if(!pois1) kasautuminen++;
                 else if(menuvalinta != 100) kasautuminen--;
                 else kasautuminen-= 0.25;
                 if(pois1 && menuvalinta != 100 && kasautuminen < 1) pois2 = true;
                 if(pois1 && menuvalinta == 100 && kasautuminen < 0.25) pois2 = true;
                 if(kasautuminen < 20) SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, int(round(255 - kasautuminen * 12.75)));
                 else SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, 0);
                 if(napit) nappikasautuminen++;
                 
                 //testataan onko hiiri nappien päällä
                 if(kasautuminen > 20 && nappikasautuminen > 10 && hiiriy > 500 && hiiriy < 550) {
                           if(hiirix > 150 && hiirix < 275) valinta = 100; //suoraan peliin
                           else if(hiirix > 363 && hiirix < 650) valinta = 2;
                           else valinta = 0;
                 }
                 else valinta = 0;
                 if(kasautuminen > 20 && hiirix < 150 && hiiriy > 550) valinta = -1; //back-nappi
                 
                 //testataan irroitettiinko hiiri napin päällä
                 if(kasautuminen > 20 && valinta != 0 && hiiriprewekanappi && !hiiriekanappi) {
                           if(valinta == -1) {
                                      pois1 = true;
                                      menuvalinta = 1;
                                      if(kasautuminen > 20) kasautuminen = 20;
                           }
                           else {
                                      menuvalinta = valinta;
                                      if(menuvalinta == 100) {
                                                     pois1 = true;
                                                     kasautuminen = 20;
                                                     Mix_FadeOutMusic(2000);
                                      }
                                      else if(menuvalinta == 2) piirtokohta = tempruutu;
                           }
                           soitaaani(nappi2); //ääni
                 }
                 
                 //nappiäänet
                 if(hiiriekanappi && !hiiriprewekanappi && valinta != 0) soitaaani(nappi1);
                 else if(valinta != prewvalinta && valinta != 0) {
                            if(hiiriekanappi) soitaaani(nappi1);
                            else soitaaani(nappion);
                 }
                 
                 //hiiren nappi painettiin
                 if(hiiriekanappi && !hiiriprewekanappi && kasautuminen > 20) {
                                  //testataan onko hiiri nappien päällä
                                  if(hiiriy > 213 && hiiriy < 288) {
                                            for(int i=0;i<3;i++) {
                                                    if(hiirix > 225 + 125 * i && hiirix < 325 + 125 * i && progressmaara >= i * 5) {
                                                              soitaaani(nappi2); //ääni
                                                              mappivalinta = i + 1;
                                                              napit = true;
                                                    }
                                            }
                                  }
                                  sprintf(viesti, "Survival%i", mappivalinta);
                                  asetakartta(viesti);
                 }
                 
                 if(menuvalinta != 100) {
                                if(pelaajaninputit[SDLK_ESCAPE]) {//ESC-nappi
                                                  if(menuvalinta != 1) soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 1;
                                                  if(kasautuminen > 20) kasautuminen = 20;
                                }
                                else if(pelaajaninputit[SDLK_RETURN] && kasautuminen > 20 && nappikasautuminen > 10) { //ENTER-nappi
                                                  soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 100; //peliin
                                                  kasautuminen = 20;
                                                  Mix_FadeOutMusic(2000);
                                }
                 }
                 
                      //Piirretään kaikki
                 piirrakuva2(menutausta, 0, 0);
                 if(piirtokohta == ruutu) piirrakuva(otsikko, 400, 50);
                 //vanhat napit
                 if(kasautuminen < 20 && menuvalinta != 100) {
                                 piirrakuva(menunappitutorial1, 400 - 30 * kasautuminen, 175);
                                 piirrakuva(menunappistages1, 400 - 30 * kasautuminen, 275);
                                 piirrakuva(menunappisurvival2[0], 400 - 30 * kasautuminen, 375);
                                 piirrakuva(menunappicustommap1, 400 - 30 * kasautuminen, 475);
                 }
                 //napit
                 if(menuvalinta != 100) {
                                if(valinta == -1 && hiiriprewekanappi) piirrakuva(nappitakaisin[2], 75, 575);
                                else if(valinta == -1) piirrakuva(nappitakaisin[1], 75, 575);
                                else piirrakuva(nappitakaisin[0], 75, 575);
                                
                                //mappinapit
                                if(kasautuminen < 20) {
                                                piirrakuva(mappinappi0, 850 + 125 * mappivalinta - 35 * kasautuminen, 250);
                                                for(int i=0;i<3;i++) {
                                                        if(progressmaara >= i * 5) piirrakuva(mappinappi[i], 975 - 35 * kasautuminen + 125 * i, 250);
                                                        else piirrakuva(mappinappilock, 975 - 35 * kasautuminen + 125 * i, 250);
                                                }
                                }
                                else {
                                                piirrakuva(mappinappi0, 150 + 125 * mappivalinta, 250);
                                                for(int i=0;i<3;i++) {
                                                        if(progressmaara >= i * 5) piirrakuva(mappinappi[i], 275 + 125 * i, 250);
                                                        else piirrakuva(mappinappilock, 275 + 125 * i, 250);
                                                }
                                }
                                
                                //play ja hiscoret
                                if(kasautuminen < 20) {
                                                if(nappikasautuminen > 10) piirrakuva(nappipelaa[0], 912 - 35 * kasautuminen, 525);
                                                else piirrakuva(nappipelaa[0], 912 - 35 * kasautuminen, 625 - 10 * nappikasautuminen);
                                }
                                else if(nappikasautuminen < 10) piirrakuva(nappipelaa[0], 212, 625 - 10 * nappikasautuminen);
                                else if(valinta == 100 && hiiriprewekanappi) piirrakuva(nappipelaa[2], 212, 525);
                                else if(valinta == 100) piirrakuva(nappipelaa[1], 212, 525);
                                else piirrakuva(nappipelaa[0], 212, 525);
                                
                                if(kasautuminen < 20) {
                                                if(nappikasautuminen > 10) piirrakuva(nappiscores[0], 1206 - 35 * kasautuminen, 525);
                                                else piirrakuva(nappiscores[0], 1206 - 35 * kasautuminen, 625 - 10 * nappikasautuminen);
                                }
                                else if(nappikasautuminen < 10) piirrakuva(nappiscores[0], 506, 625 - 10 * nappikasautuminen);
                                else if(valinta == 2 && hiiriprewekanappi) piirrakuva(nappiscores[2], 506, 525);
                                else if(valinta == 2) piirrakuva(nappiscores[1], 506, 525);
                                else piirrakuva(nappiscores[0], 506, 525);
                 }
                 else {
                                piirrakuva(nappitakaisin[0], 75, 1375 - 40 * kasautuminen);
                                piirrakuva(mappinappi0, 150 + 125 * mappivalinta, 250);
                                for(int i=0;i<3;i++) {
                                        if(progressmaara >= i * 5) piirrakuva(mappinappi[i], 275 + 125 * i, 250);
                                        else piirrakuva(mappinappilock, 275 + 125 * i, 250);
                                }
                                piirrakuva(nappipelaa2, 212, 525);
                                piirrakuva(nappiscores[0], 506, 525);
                 }
                 //loput
                 if(showfpseverywhere == 2) piirraexpluku(fps, 7);
                 piirrakuva2(menutahtain, hiirix - 1, hiiriy - 1);
                 if(kasautuminen < 20 && menuvalinta == 100) piirrakuva2(valkoinenfade, 0, 0); //fade kaiken päälle
                 
                 SDL_Flip(ruutu);
                 
                 //Lopussa tehtävät asiat
                 if(hiiriekanappi) hiiriprewekanappi = true;
                 else hiiriprewekanappi = false;
                 prewvalinta = valinta;
                 
                      if(hoidatapahtumat()) pois2 = true;
                      laskefps();
                      
                 if(menuvalinta == 2) naytahiscoret(false); //näytetään hiscoret tähän väliin
                      
    //tähän loppuu menun looppi
    }
}
